var $_woowaitlist_license_str = {};

$_woowaitlist_license_str.first_save_settings = woowaitlist_back_ajax_object.texts.first_save_settings;
$_woowaitlist_license_str.already_activated = woowaitlist_back_ajax_object.texts.already_activated;
$_woowaitlist_license_str.activation_error_ajax = woowaitlist_back_ajax_object.texts.activation_error_ajax;
$_woowaitlist_license_str.deactivation_error_ajax = woowaitlist_back_ajax_object.texts.deactivation_error_ajax;
$_woowaitlist_license_str.is_not_activated = woowaitlist_back_ajax_object.texts.is_not_activated;

function waitlist_isChecked(e) {

	'use strict';

	var $r;

    if ( e.attr("checked") !== undefined ) {

        $r = 1;
    }

    else {

        $r = 0;
    }

    return $r;
}

function waitlist_sender_emailAddress(){

	"use strict";

	var sel = jQuery('#woowaitilist-default-email-options');

	if( waitlist_isChecked( sel ) ){

		jQuery('.woowaitilist-custom-email').slideUp( 'fast', function(){
			jQuery(this).addClass("hidden");
		});
	}
	else{

		jQuery('.woowaitilist-custom-email').slideDown( 'fast', function(){
			jQuery(this).removeClass("hidden");
		});
	}
}

(function ( $ ) {
	
	"use strict";

	$(function () {

		waitlist_sender_emailAddress();

		jQuery('#woowaitilist-default-email-options').on('click', function(){

			waitlist_sender_emailAddress();
		});

		jQuery('.woowaitlist-settings-save').live( 'click', function(){

			var form_data = jQuery('.woowaitlist-settings-form').serialize();

			jQuery('.woowaitlist-settings-form .updated').slideUp(function(){

				jQuery(this).remove();
			});
			
			jQuery.ajax({
				type: "post",
				url: woowaitlist_back_ajax_object.ajax_url,
				dataType: 'json',
				data: {
					action: 'woowaitlist_save_settings',
					p: form_data
				},
				success:function(data, textStatus, XMLHttpRequest){

					if( data && data.message ){

						jQuery('.woowaitlist-settings-form').prepend( data.message );

						jQuery('html, body').animate({
					        scrollTop: jQuery("#woowaitlist-top").offset().top
					    }, 500);
					}

				},
				error:function(data, textStatus, XMLHttpRequest){

					console.log('error ajax - woowaitilist save settings');
				}
			});

			return false;
		});

		woowaitlist_verify_purchase_code();
	});

}(jQuery));

function woowaitlist_on_license_activation_complete( msg, error ){

	jQuery('.woowaitlist-license-buttons').removeClass('activating');

	if( !error ){
			
		jQuery('.form-product-license').removeClass('to-activate');

		jQuery('.form-product-license input[type="text"]').attr('disabled', 'disabled');
		jQuery('.form-product-license .woowaitlist-product-license-settings-save').attr('disabled', 'disabled');

		jQuery('#woowaitlist_is_active_license').val( 1 );
		jQuery('#woowaitlist_can_activate').val( 0 );
	}
	
	if( msg ){
	
		woowaitlist_display_license_message( msg, error );
	}
}

function woowaitlist_on_license_deactivation_complete( msg, error ){
	
	jQuery('.woowaitlist-license-buttons').removeClass('activating');

	if( !error ){

		jQuery('.form-product-license').addClass('to-activate');

		jQuery('.form-product-license input[type="text"]').removeAttr('disabled');
		jQuery('.form-product-license .woowaitlist-product-license-settings-save').removeAttr('disabled');

		jQuery('#woowaitlist_is_active_license').val( 0 );
		jQuery('#woowaitlist_can_activate').val( 1 );
	}

	if( msg ){
	
		woowaitlist_display_license_message( msg, error );
	}
}

function woowaitlist_verify_purchase_code(){

	jQuery('.woowaitlist-activate-license').on("click", function(){

		var can_activate = parseInt( jQuery('#woowaitlist_can_activate').val(), 10 ),
			is_already_active = parseInt( jQuery('#woowaitlist_is_active_license').val(), 10 );

		if( is_already_active === 1 ){
			
			woowaitlist_display_license_message( $_woowaitlist_license_str.already_activated, 1 );

			woowaitlist_on_license_deactivation_complete();
		}
		else{

			if( can_activate === 1 ){

				jQuery('.woowaitlist-license-buttons').addClass('activating');

				jQuery.ajax({
					type: "post",
					url: woowaitlist_back_ajax_object.ajax_url,
					dataType: "json",
					data: {
						action: 'woowaitlist_activate_license'
					},
					success:function(data, textStatus, XMLHttpRequest){

						console.log( data );

						if( data.error === 1 ){
							
						}
						else{

						}

						woowaitlist_on_license_activation_complete( data.msg, data.error );
					},
					error:function(data, textStatus, XMLHttpRequest){

						console.log( data );
						console.log( textStatus );

						console.log('error ajax - WooWaitlist activate license');

						woowaitlist_on_license_activation_complete( $_woowaitlist_license_str.activation_error_ajax, 1 );
					}
				});
			}
			else{

				woowaitlist_display_license_message( $_woowaitlist_license_str.first_save_settings, 1 );
			}
		}

		return false;
	});

	jQuery('.woowaitlist-deactivate-license').on("click", function(){
		
		var is_already_active = parseInt( jQuery('#woowaitlist_is_active_license').val(), 10 );

		if( is_already_active === 1 ){
		
			jQuery('.woowaitlist-license-buttons').addClass('activating');

			jQuery.ajax({
				type: "post",
				url: woowaitlist_back_ajax_object.ajax_url,
				dataType: "json",
				data: {
					action: 'woowaitlist_deactivate_license'
				},
				success:function(data, textStatus, XMLHttpRequest){

					console.log( data );

					if( data.error === 1 ){

					}
					else{

					}

					woowaitlist_on_license_deactivation_complete( data.msg, data.error );
				},
				error:function(data, textStatus, XMLHttpRequest){

					console.log('error ajax - WooWaitlist deactivate license');
					woowaitlist_on_license_deactivation_complete( $_woowaitlist_license_str.deactivation_error_ajax, 1 );
				}
			});
		}
		else{

			woowaitlist_display_license_message( $_woowaitlist_license_str.is_not_activated, 1 );

			woowaitlist_on_license_activation_complete();
		}

		return false;		
	});
}

function woowaitlist_hide_license_message(){

	jQuery( '.woowaitlist-license-messages' ).fadeOut();
}

function woowaitlist_display_license_message( c, error ){

	if( c ){
		
		if( error ){

			jQuery( '.woowaitlist-license-messages' ).addClass('error');
		}
		else{

			jQuery( '.woowaitlist-license-messages' ).removeClass('error');
		}

		jQuery( '.woowaitlist-license-messages' ).html( c ).fadeIn();
	}
}