<?php
/*
Plugin Name: WooWaitlist
Plugin URI: http://www.woowaitlist.com
Description: WooWaitlist, a waitlist plugin for your WooCommerce website by WPCream.com.
Author: WPCream.com
Version: 3.0.10
Author URI: http://wpcream.com
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

$woowaitlist_purchase_url = 'http://codecanyon.net/item/woowaitlist-woocommerce-back-in-stock-notifier/7103373';
$woowaitlist_service_url = 'http://104.236.248.154/fd78fgd/wtlst/verify-purchase-code/';

if ( ! defined( 'WOOWAITLIST_UPDATE_API_URL' ) ) {
	 
	define( 'WOOWAITLIST_UPDATE_API_URL', $woowaitlist_service_url );
}

if ( ! defined( 'WOOWAITLIST_PURCHASE_URL' ) ) {
	
	define( 'WOOWAITLIST_PURCHASE_URL', $woowaitlist_purchase_url  );
}

/*----------------------------------------------------------------------------*
 * Public-Facing Functionality
 *----------------------------------------------------------------------------*/


require_once( plugin_dir_path( __FILE__ ) . 'public/class-woocommerce-waitlist.php' );
require_once( plugin_dir_path( __FILE__ ) . 'public/class-woowaitlist_update_plugin.php' );

/*
 * Register hooks that are fired when the plugin is activated or deactivated.
 * When the plugin is deleted, the uninstall.php file is loaded.
 *
 */
register_activation_hook( __FILE__, array( 'Woocommerce_Waitlist', 'activate' ) );
register_deactivation_hook( __FILE__, array( 'Woocommerce_Waitlist', 'deactivate' ) );

add_action( 'plugins_loaded', array( 'Woocommerce_Waitlist', 'get_instance' ) );

/*----------------------------------------------------------------------------*
 * Dashboard and Administrative Functionality
 *----------------------------------------------------------------------------*/

/*
 *
 * If you want to include Ajax within the dashboard, change the following
 * conditional to:
 *
 * if ( is_admin() ) {
 *   ...
 * }
 *
 * The code below is intended to to give the lightest footprint possible.
 */

function on_woocommerce_waitlist_loaded(){
	
	$canView_settings = false;

	if( is_user_logged_in() ){

		global $current_user, $wpdb;

		$allowed_settings_role = array( "administrator" );

		$wew_enable_shop_manager_settings = get_option('wew-enable-shop-manager-settings') && get_option('wew-enable-shop-manager-settings') == "on" ? true : false;

		if( $wew_enable_shop_manager_settings ){

			$allowed_settings_role[] = "shop_manager";
		}

		$user = get_userdata( $current_user->ID );

		$capabilities = $user->{$wpdb->prefix . 'capabilities'};

		if ( !isset( $wp_roles ) ){
		
			$wp_roles = new WP_Roles();
		}

		foreach ( $wp_roles->role_names as $role => $name ){

			if ( array_key_exists( $role, $capabilities ) ){

				if( !$canView_settings && in_array( $role, $allowed_settings_role ) ){

					$canView_settings = true;
				}

			}
	
		}
	
	}

	if( $canView_settings ){

		require_once( plugin_dir_path( __FILE__ ) . 'admin/class-woocommerce-waitlist.php' );
		
		Woocommerce_Waitlist_Admin::get_instance();
	}
}

function get_wew_records( $user_email = false ){

	global $wpdb;

	$wew_DBtable_name = $wpdb->prefix . 'woocommerce_waitlist';

	if( $user_email ){

		$ret = $wpdb->get_results("SELECT * FROM " . $wew_DBtable_name . " WHERE email='" . trim( $user_email ) . "' ORDER BY date DESC");
	}
	else{

		$ret = $wpdb->get_results("SELECT * FROM " . $wew_DBtable_name . " ORDER BY date DESC");
	}

	return $ret;
}

if ( ! defined( 'DOING_AJAX' ) || ! DOING_AJAX ) {

	add_action( 'plugins_loaded', 'on_woocommerce_waitlist_loaded' );

	$update_plugin = new woowaitlist_update_plugin;
	$update_plugin->woocommerce_woowaitlist_init_auto_update();

	if( isset( $_POST['action'] ) && $_POST['action'] == 'update_author_waitlist' ){

		if( isset( $_POST['wewd_id'] ) && !is_null( $_POST['wewd_id'] ) ){

			global $wpdb;

			$wew_DBtable_name = $wpdb->prefix . 'woocommerce_waitlist';

			$removeArr = $_POST['wewd_id'];

			$q = "DELETE FROM " . $wew_DBtable_name ." WHERE id IN( ". implode(',', $removeArr ) ." )";

			$wpdb->query( $q );

			header( 'Location: ' . get_permalink() );
			exit;
		}
	}
	
}